function [A_,B_,C_]=armax_rls(Y,U,n,Tm)
%
%       [A,B,C]=armax_rls(Y,U,n)
%
%
%       Y=G*U+H*E
%
%       n=[na nb nc]
%       na: orden A
%       nb: orden B
%       nc: orden C
%

if(nargin<4)
    Tm=-1;
end

na=n(1);
nb=n(2);
nc=n(3);

np=na+nb+nc;         
N=length(U);
y=zeros(1,na);
u=zeros(1,nb);
e=zeros(1,nc);
P=1e6*eye(np,np);
C=[ y u e ];
X=zeros(np,1);
I=eye(np,np);
lambda=0.99;
for k=1:N
    yk=Y(k);
    uk=U(k);
    PCt=P*C';
    L=PCt/(C*PCt+lambda);
    ek=yk-C*X;
    X=X+L*ek;
    ek2=yk-C*X;
    P=(I-L*C)*P/lambda;
    y=[-yk y(1:end-1)];
    if nb>0
    u=[uk u(1:end-1)];
    else
        u=[];
    end
    e=[ek2 e(1:end-1)];
    C=[ y u e ];
    A_(k,:)=[ 1 X(1:na)'];
    B_(k,:)=X(na+1:na+nb)';
    C_(k,:)=[1 X(na+nb+1:na+nb+nc)'];
end
