function [smap,MSE] = bsom(u,y,smap,epochs,Nc,weights,Bidx)



if nargin == 1
    smap = inisom(p);
end

if nargin <= 2
    epochs = 50;
    Nc = 1;
end


Q   = size(u,2);

% Neighbourhood selection
lnc = length(Nc);
if lnc==1
    neigh = logspace(log10(max([cat(1,smap.dims{:})]/3)),log10(Nc),epochs);
elseif lnc==2
    neigh = logspace(log10(Nc(1)),log10(Nc(2)),epochs);
elseif lnc>2
    if lnc~=epochs
        error('length of neighborhood vector does not match number of epochs');
    end;
    neigh = Nc;
end;


idx = 2:Q;

[xx,yy]=tddata(u,y,1,0);

smap.R = size(xx,1);

%smap.w = rands(smap.S,smap.R);
smap.w = 2*rand(smap.S,smap.R)-1;

for ke = 1:epochs
    idxperm = randperm(size(xx,2));
    xx = xx(:,idxperm);
    yy = yy(:,idxperm);
    for k = 1:size(xx,2)
        yest = smap.w*xx(:,k);

        err = yest-yy(:,k);
        [ee,bmu] = min(err.^2);

        hci   = smap.dis(:,bmu)<=neigh(ke);
        smap.w = smap.w - .01*repmat(hci,1,smap.R).*repmat(err,1,smap.R).*repmat(xx(:,k)',smap.S,1);

        MSE(ke) = mean(ee);
    end;
    if 1
        figure(1);
        plotsom(smap);
        axis equal;
        axis([-2 2 -2 2]);
        drawnow;
    end
%     if ~rem(ke,epochs/10)
%         fprintf('Epoca: %d,\t Vecindad: %f,\t mse: %f\t mse (p.u.): %f \n',ke,neigh(ke),MSE(ke), MSE(ke)/MSE(1));
%     end

end


