%   UNIOVISOM Toolbox
%   Version 2.0, June 1, 2007
%   
%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%   
%   
%   
%   MAIN FUNCTIONS
%
%   General visualization:
%correlationmatrix - Interactive plot of correlation matrix
%       pdfscatter - Scatter plot with superimposed pdf plot
%           planes - Draws 2D component planes
%         planes3d - Draws 3D component planes
%          plotcov - Plots 2D covariance ellipsoids
%            plotp - Plots 2D and 3D points
%        tablelens - Table Lens data visualization
%          varplot - Plots variables of a data matrix in separate plots
%
%   SOM functions:
%       activation - Activation maps generated by a given input data set of stimuli
%             bsom - Train a SOM using the batch SOM training algorithm
%            bproj - Backward projection with the SOM mapping
%            fproj - Forward projection with the SOM mapping
%           inisom - Initialize a SOM structure
% localcorrelation - Local correlation maps
%          somdist - SOM distance matrix
%        sominterp - Resample a given SOM to obtain a thinner one
%
%   Function approximation
%          grnntra - Train a normalized RBF (GRNN)
%          grnnsim - Simulate a normalized RBF (GRNN) from input data
%           linreg - Linear regression
%
%  SOM-based Visualization of Dynamics
%         mloc_som - Entrena un SOM en el espacio "embedded" para segmentar dinmicas
%         mloc_loc - Entrena modelos locales tipo ARX de un SOM 
%      mloc_planos - Dibuja los planos de coeficientes, variables selectoras y RMSE
%         mloc_sim - Simula un SOM de modelos locales
%     mloc_compara - Compara la aproximacin lineal y la MLOC con los datos originales
%        mloc_info - Imprime en pantalla informacin sobre el SOM de modelos locales
%
%
%
%   Other functions
%        clouddata - Generates clouds of points for testing algorithms
%         datagrid - Generates points of an N-D grid with specified limits
%            excar - Computes energies in frequency bands from data matrix
%        fuzzymaps - Obtains SOM fuzzy maps interactively
%             fcms - Fuzzy C-means algorithm for unsupervised
%                    classification
%        getpoints - Gets 2D points from mouse clicks
%          matdiff - Cartesian product of vector differences between two vector sets
%          matdist - Matrix of mutual distances between two vector sets
%        modelmaps - Gets polynomial models from data interactively
%           parzen - Estimates joint pdf using parzen kernels
%           rectop - Stores cartesian product of indices on an N-D grid
%          rectopi - Generate points of a thinner rectangular N-D grid
%           region - Interactively highlight regions in the visualization space

