% demo_grnn_1D: 1D GRNN REGRESSION DEMO

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

figure(1);
clf;

% Create 30 sample points according to a known nonlinear model
N  = 30;
xi = rands(1,N);
yi = xi.^2 + 0.05*randn(1,N);

% plot the points
plot(xi,yi,'.');
grid on;

% width factor
sigma = 10.0;

% train the grnn model (use LS to compute weights)
grnn = grnntra(yi,xi,sigma,1e-6);

% test the model on the interval [-1.1,1.1]
x = linspace(-1.1,1.1,1000);

% predict the y-value using the trained model
yestim = grnnsim(x,grnn);

% plot the results 
hold on;
plot(x,yestim,'r','linewidth',2);
grid on;
hold off;

