function dis=distenlace(pos)
% DISTENLACE Link distances between SOM nodes
%
% dis = distenlace(pos)
%
% INPUTS
% pos: Matrix with 2D coordinates of SOM nodes (2xS)
%
% OUTPUTS
% dis: Square matrix (SxS) with link distances
%
% DESCRIPTION
%   Obtains link distance between all nodes of a rectangular grid

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


S = size(pos,2);
%dis=reshape(sum(abs(matdiff(pos,pos)),1),S,S);
%dis=uint8(zeros(S,S));
dis=zeros(S,S,'uint8');
for k=1:S
   dis(k,:)=uint8(sum(abs(pos-repmat(pos(:,k),1,S)),1));
end


%DISTANCIA QUE USAN EN SOMTOOLBOX
%dis = zeros(S,S);
%for k=1:S
%   dco = pos'-pos(:,ones(S,1)*k)'; 
%   dis(k,:)=sqrt(sum(dco'.^2));
%end
