% [T,P] = exfdt (u,y,p,AR,MA,bias,fm,nfft,solap)
function [T,P] = exfdt (u,y,p,AR,MA,bias,fm,nfft,solap)

N = size(u,2);


ny = 1:AR;
nu = 0:MA;

nsolap = floor(nfft*solap);
[Y,idx] = reforma(y,nsolap,nfft);
[U,idx] = reforma(u,nsolap,nfft);


ly = size(Y,2);
% FUNCIONES DE TRANSFERENCIA
if MA==-1
    disp('Modelo AR puro... utilizando mtodo LPC');
    disp('Eliminando la media...');
    T.bias = mean(Y);
    disp('Calculando coeficientes LPC...');
    [A,E] = lpc(Y-repmat(T.bias,size(Y,1),1),AR);
    T.den = A';
    T.num = E';    
else
    disp('Modelo ARX... utilizando ajuste por mnimos cuadrados');
    for k = 1:ly
        aux(:,k) = mloc_glo(Y(:,k)',U(:,k)',ny,nu,bias)';
    end
    T.den  = [ones(1,ly); -aux(1:AR,:)];
    T.num  = aux(AR+1:AR+MA+1,:);
    if bias
        T.bias = aux(AR+MA+2,:);
    else
        T.bias = zeros(1,size(aux,2));
    end
end

% PUNTO DE TRABAJO    
disp('Obteniendo punto de trabajo...');
for k = 1:size(p,1)
    P(k,:) = mean(reforma(p(k,:),nsolap,nfft));
end

disp('Calculando respuesta en frecuencia para f = 0..fshannon (100 puntos)');
th    = linspace(0,pi,100);
T.Gjw = multibode(T.num,T.den,th);
T.f   = th*(fm/(2*pi));


disp('Hecho.');