function label(hfig,pos,textstr,fontsize)
% LABEL Places a given label in prespecified positions of V
%
% CALLS
% label(hfig,pos,textstr,fontsize)
%
%    hfig: array of handles to axes containing the SOM planes
%     pos: matrix (2xQ) containing the positions of the labels
% textstr: {1xQ} cell with text strings of the labels.
%          It can also be a single string if a signle label is to be
%          assigned to all points
%fontsize: Font size in points
%
% DESCRIPTION
%   SOMLABEL allows to draw labels in the visualization space V by
%   specifying the positions and the label texts.
%

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

if nargin<4
    fontsize=6;
end

if ~iscell(textstr)
    for k = 1:length(hfig)
        axes(hfig(k));
        text(pos(1,:),pos(2,:),textstr,'fontsize',fontsize,'horizontalalignment','center','fontweight','bold','color',0.0*[1,1,1]);
    end
else
    for k = 1:length(hfig)
        axes(hfig(k));
        text(pos(1,:),pos(2,:),textstr(:),'fontsize',fontsize,'horizontalalignment','center','fontweight','bold','color',0.6*[1,1,1]);
    end
end    
