function [y,res] = localreg(x,yi,xi,m,lambda)

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


if nargin==3
    m = 10;
    lambda = 0;
elseif nargin==4
    lambda = 0;
end


N = size(x,2);
nx  = size(xi,2);
ny  = size(yi,2);
lx = size(xi,1);
ly = size(yi,1);

[xin,xnpar] = normalize_data('std',xi);
[yin,ynpar] = normalize_data('std',yi);
[xn] =        normalize_data('apply',x,xnpar);

for k = 1:N
    [ds,idx] = sort(matdist(xin,xn(:,k)));
    ylocal = yin(:,idx(1:m));
    xlocal = xin(:,idx(1:m));
    T = linreg(ylocal,[xlocal;ones(1,m)],lambda);    
    yn(:,k) = T*[xn(:,k);1];
    
    % CALCULO DE RESIDUOS DEL MODELO (EXPERIMENTAL)
    if nargout==2
        grnn = grnntra(xlocal,xlocal,0.2);
        resn(:,k) = xn(:,k)-grnnsim(xn(:,k),grnn);
    end
end

y = normalize_data('reverse',yn,ynpar);


% DESNORMALIZACION DE RESIDUOS DEL MODELO
if nargout==2
    xnpar.meanx=0*xnpar.meanx;
    res = normalize_data('reverse',resn,xnpar);
end

