function d_ij = matdist1(Xi,Xj)
% MATDIST1
% d_ij = matdist1(Xi,Xj)

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

ni = size(Xi,2);
nj = size(Xj,2);


TBi = min([500,ni]);
TBj = min([500,nj]);

d_ij = zeros(ni,nj);
for ki = TBi:TBi:ni
    for kj = TBj:TBj:nj
        idxi = (1:TBi) + ki - TBi;
        idxj = (1:TBj) + kj - TBj;
        d_ij(idxi,idxj) = matdist(Xi(:,idxi),Xj(:,idxj));
    end
end

idxi = ki+1:ni;
idxj = kj+1:nj;
d_ij(idxi,idxj) = matdist(Xi(:,idxi),Xj(:,idxj));
d_ij(1:ki,idxj) = matdist(Xi(:,1:ki),Xj(:,idxj));
d_ij(idxi,1:kj) = matdist(Xi(:,idxi),Xj(:,1:kj));

