% MDSFAST:
% Copyright (c) Ignacio Daz, 2009

function pr = mdsfast(d,dim,epochs,mu);

if nargin<4
    mu = 0.05;
end
if nargin<3
    epochs = 100;
end
if nargin < 2
    dim = 2;
end


n = length(d);


% Normalizacin de la matriz de distancias (0,1)
d = d-min(d(:));
d = d/max(d(:));

p  = randn(dim,n);

lr = linspace(0.05,0.01,epochs);

for k = 1:epochs
    centro = randperm(n);
    for i = 1:n
        m   = centro(i);
        idx = [1:m-1 m+1:n];
        dp  = repmat(p(:,m),[1,n-1])-p(:,idx);
        D   = sum(dp.^2,1);
        mu  = lr(k)*repmat(D - d(m,idx),[dim,1]);
        p(:,idx) = p(:,idx) + mu.*dp;
    end
    if ~rem(k,2)
        error = matdist(p,p)-d;
        fprintf('Epoca: %d / %d \t error: %g\t %g\n',k,epochs,sum(error(:).^2),max(abs(mu(1,:))));
    end

end
pr = p;