function [rmseloc,yloc,rmselin,ylin,AICloc,AIClin]=mloc_compara(y,u,p,mloc);
% MLOC_COMPARA Compara la aproximacin lineal y la MLOC con los datos originales
%
%       [rmseloc,yloc,rmselin,ylin,AICloc,AIClin]=mloc_compara(y,u,p,mloc)
%
% INPUTS
%    y: Variable de salida del sistema
%    u: Variable de entrada al sistema
%    p: Variables selectoras de la dinmica
% mloc: Objeto mloc
%
%

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



% Condiciones iniciales
y0 = y(:,1:mloc.ny(end));


% Simulamos modelo lineal
ylin = mloc_simlin(u,mloc,y0);


% Simulamos SOM con modelos locales

% 2007.01.31: BORRADO ESTE CDIGO. NO ENTIENDO POR QU PUSE LA OPCIN DE "yloc = mloc_sim(u,mloc,y0)"
% if size(p)
%     yloc = mloc_sim(u,mloc,p,y0);
% else
%     yloc = mloc_sim(u,mloc,y0);
% end

[yloc,pr] = mloc_sim(u,mloc,p,y0);



t = 1:length(u);
rmselin = sqrt(mean((y-ylin).^2));
rmseloc = sqrt(mean((y-yloc).^2));
AICloc = log(mean((y-yloc).^2)) + 2*length(mloc.Mcell{1})/length(yloc);
AIClin = log(mean((y-ylin).^2)) + 2*length(mloc.Mcell{1})/length(yloc);

if nargout==0
    % figure;
    subplot(211);
    plot(t,y,t,ylin,'r:');
    legend('real','lin');
    title(sprintf('RMSE lineal = %1.3g,  RMSE mloc   = %1.3g',rmselin,rmseloc));
    subplot(212);
    plot(t,y,t,yloc,'r:');
    legend('real','loc');
end;
