function G = mloc_getmatrix(mloc)
% MLOC_GETMATRIX 

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


% Se recuperan algunos parmetros obtenidos en la etapa anterior
nq  = mloc.nq;
np  = mloc.np;
nu  = mloc.nu;
ny  = mloc.ny;
Ry  = mloc.Ry;
Ru  = mloc.Ru;

idxu = size(ny,2)*Ry+(1+Ru*nu),
idxy = Ry*(ny-1)+1,

for k = 1:mloc.som.S
    for i = 1:Ry,
        for j = 1:Ru
            num{i,j} = mloc.Mcell{k}(i,idxu+j-1);
            den{i,j} = [1 -mloc.Mcell{k}(i,idxy+i-1)];
        end
    end
    G{k} = tf(num,den,1);
end



% 
% % disp('Determinando modelo lineal global a efectos de comparacin...');
% mloc.Tlineal = mloc_glo(y,u,ny,nu,usar_bias);
% 
% 
% if nargin==6
%     usar_bias = 1;
%     sigma = 8;
% elseif nargin == 7
%     sigma = 8;
% end
%     
% 
% % Se crean vectores "augmented"
% idx = max([ny nu np nq])+1:length(y);
% 
% % Variable "augmented" de salida del proceso
% phiy = [];
% for j = 1:length(ny)
%     phiy = [phiy;y(:,idx-ny(j))];
% end
% 
% % Variable "augmented" de entrada al proceso
% phiu = [];
% for j = 1:length(nu)
%     phiu = [phiu;u(:,idx-nu(j))];
% end
% 
% % VARIABLES SELECTORAS DE DINMICA
% % Al considerar retardos incluimos la propia dinamica de la variable como
% % elemento de seleccion en la dinamica del proceso. Como caso particular,
% % haciendo p = y, tenemos el caso de procesos no lineales descrito por [Cho
% % y Principe]
% 
% 
% % Inicializacin
% phip = [];
% 
% % Parte endgena
% for j = 1:length(nq)
%     phip = [phip;y(:,idx-nq(j))];
% end
% 
% % Parte exgena
% for j = 1:length(np)
%     phip = [phip;p(:,idx-np(j))];
% end
% 
% pp = norpca(phip,A,b);
% 
% 
% 
% % 2007-12-07: para el caso multivariable (cuando los vectores de y
% % tienen dimensin mayor que 1, la variable ytot debe contener vectores de
% % tamao Ry x Q
% 
% % ytot = y(idx);        % Codigo anterior
% ytot = y(:,idx);
% 
% 
% 
% 
% lambda = 1e-5;
% pr = fproj(pp,som);
% for k = 1:som.S, 
%     if ~rem(k,50)
%         fprintf('.');
%     end
% 
%     distancias = sqrt(matdist(pr,som.pos(:,k)));    % obtenemos las distancias de la neurona actual (cuyo modelo local se va a calcular) 
%                                                     % a cada bmu del vector de ndices de modelo phip
%     idx = find(distancias < sigma);                 % nos quedamos slo con las neuronas cuya distancia es inferior a una dada (ej. 10)
%     
%     % 2006-09-22
%     % Nota: en la versin mltra_v01 se consideraban pesos para cada dato de acuerdo con la proximdad 
%     % de la bmu a la neurona actual. El mtodo era mucho ms lento y parece que apenas se mejora el 
%     % resultado. El procedimiento seguido aqu es una especie de "proximidad burbuja"
% 
% 
%                                                     
%     % Trmino de bias. Permite computar un modelo afn, 
%     % es decir, con un parmetro independiente que
%     % permite considerar medias no nulas
%     if usar_bias
%         bias = ones(1,length(idx)); 
%     else
%         bias = [];                  
%     end
%     if length(phiu)
%         % [T,RMSE(k),rango(k)] = linreg(ytot(idx),[phiy(:,idx);phiu(:,idx);bias],lambda); 
%         % modificado el 2007-12-07
%         % para el caso multivariable (cuando los vectores de y
%         % tienen dimensin mayor que 1, la variable ytot debe contener vectores de
%         % tamao Ry x Q
%         [T,RMSE(k),rango(k)] = linreg(ytot(:,idx),[phiy(:,idx);phiu(:,idx);bias],lambda); % Se obtienen los coeficientes del modelo 
%                                                                                % para la neurona actual a partir 
%                                                                                % de los datos cuyas
%                                                                                % bmu caen en un
%                                                                                % entorno prximo
%     else
%         [T,RMSE(k),rango(k)] = linreg(ytot(idx),[phiy(:,idx);bias],lambda);             % caso particular cuando phiu 
%                                                                                % est vaco (el modelo es AR puro y no hay entradas)
%     end
%     Mcell{k} = T;                                      % La matriz T contiene los parmetros del modelo 
%                                                        % local asociado a cada neurona. Dichos
%                                                        % parmetros son los coeficientes de la
%                                                        % funcin de transferencia entre entrada y
%                                                        % salida (ms el parmetro de bias, si lo hay)
% 
% end; 
% 
% 
% fprintf('\n');
% 
% 
% 
% % GUARDANDO LOS DATOS EN UN OBJETO TIPO mloc
% mloc.nu = nu;                       % Nmero de retardos de los modelos ARX (parte X)
% mloc.ny = ny;                       % Nmero de retardos de los modelos ARX (parte AR)
% mloc.Mcell = Mcell;                 % Cell array con los modelos ARX asociados a cada prototipo
% mloc.usar_bias = usar_bias;         % flag de uso de trmino bias
% mloc.rmse = RMSE;                   % plano con los errores de estimacin
% mloc.rango = rango;
% mloc.sigma = sigma;