function [T,rmse] = mloc_glo(y,u,ny,nu,usar_bias)
% MLOC_GLO: Estima un modelo lineal global a efectos de comparacin
% T = mloc_glo(y,u,ny,nu,usar_bias)

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


% Se crean vectores "augmented"
idx = max([ny nu])+1:length(y);

% Variable "augmented" de salida del proceso
phiy = [];
for j = 1:length(ny)
    phiy = [phiy;y(:,idx-ny(j))];
end

% Variable "augmented" de entrada al proceso
phiu = [];
for j = 1:length(nu)
    phiu = [phiu;u(:,idx-nu(j))];
end

ytot = y(:,idx);

% ESTIMACIN DEL MODELO LINEAL GLOBAL 

% ANTIGUO: ESTE VALOR DEL PARMETRO DE REGULARIZACIN DEGRADABA DEMASIADO LA SOLUCIN
% lambda = 1e-5;

% 2010-07-06: 
% El parmetro de regularizacin en ocasiones degrada demasiado
% la solucin. Se comprob en algunos casos que bajarlo a 1e-9 o incluso
% dejarlo a cero produca los resultados esperables. Por el contrario, no
% se han constatado apenas casos en los que sea necesario regularizar la 
% solucin mediante un valor distinto de cero. Por tanto, se deja este valor a cero
% por defecto.
lambda = 0;

if ~exist('usar_bias')
    usar_bias = 0;
end
    
if usar_bias
    [T,rmse] = linreg(ytot,[phiy;phiu;ones(size(idx))],lambda);
else
    [T,rmse] = linreg(ytot,[phiy;phiu],lambda);
end




