function mloc = mloc_info(mloc,etiq_y,etiq_u,etiq_p)
% MLOC_INFO Imprime en pantalla informacin sobre el SOM de modelos locales
%
%        mloc_info(mloc)
%

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%
%     UniOviSOM toolbox is free software; you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation; either version 2 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program; if not, write to the Free Software
%     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

if nargin==4
    mloc.etiq_u=etiq_u;
    mloc.etiq_y=etiq_y;
    mloc.etiq_p=etiq_p;
end
    
% clc;
fprintf('\n');
fprintf('\n');
fprintf('Informacin del modelo local:\n');
fprintf('\n');
fprintf('            SOM: {%d,%d}\n',mloc.som.dims{1},mloc.som.dims{2});
fprintf('          sigma: %g \n',mloc.sigma);
if mloc.usar_bias
fprintf('           bias: s \n');
else
fprintf('           bias: no \n');
end

fprintf('           rmse: %g\n',mean(mloc.rmse));

if ~isempty(mloc.nu)
    fprintf('           Tipo: ARX(%d,%d) \n',mloc.ny(end),mloc.nu(end));
else
    fprintf('           Tipo: AR(%d) \n',mloc.ny(end));
end


fprintf('\n');
fprintf('  Vectores de datos:\n');
fprintf('        Phiy(k) = [');
for k = mloc.ny
    fprintf('y(k-%d)',k);
    if k~=mloc.ny(end)
        fprintf(', ');
    end
end
fprintf(']\n');

fprintf('        Phiu(k) = [');
for k = mloc.nu
    if k
        fprintf('u(k-%d)',k);
    else
        fprintf('u(k)');
    end;
    if k~=mloc.nu(end)
        fprintf(', ');
    end
end
fprintf(']\n');



fprintf('        Phip(k) = [');
for k = mloc.nq
    if k
        fprintf('y(k-%d)',k);
    else
        fprintf('y(k)');
    end;
    if k~=mloc.nq(end)
        fprintf(', ');
    end
end
fprintf(' | ');
for k = mloc.np
    if k
        fprintf('p(k-%d)',k);
    else
        fprintf('p(k)');
    end;
    if k~=mloc.np(end)
        fprintf(', ');
    end
end
fprintf(']          (nomenclatura: [parte_endogena | parte_exogena]  )\n');

[n,i]=hist(mloc.rango,0:10);
Histograma_de_rangos=[i;n],





