function yest = mloc_simlin(u,mloc,y0)
% MLOC_SIMLIN Simula un modelo lineal global
%
%             yest = mloc_simlin(u,mloc,y0)

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


T  = mloc.Tlineal;
ny = mloc.ny;
nu = mloc.nu;
usar_bias = mloc.usar_bias;



yest = zeros(size(mloc.Mcell{1},1),size(u,2));

if nargin==3
    yest(:,1:size(y0,2)) = y0;
end



% yest = zeros(size(T,1),size(u,2));

for k = max([ny nu])+1:length(u)
    phiy = [];
    for j = 1:length(ny)
        phiy = [phiy;yest(:,k-ny(j))];      % Construimos el vector "augmented" de salida con las salidas estimadas anteriores
    end

    phiu = [];
    for j = 1:length(nu)
        phiu = [phiu;u(:,k-nu(j))];         % Construimos el vector "augmented" de entrada con las entradas anteriores
    end

    if usar_bias
        yest(:,k) = T*[phiy;phiu;1];      % Estimacion mediante el modelo local actual (usando trmino bias)
    else
        yest(:,k) = T*[phiy;phiu];        % Estimacion mediante el modelo local actual (sin usar trmino bias)
    end
end










