function [mloc,A_,N_] = mloc_tf(mloc)


Q = length(mloc.Mcell);

nu = mloc.nu;
ny = mloc.ny;
lnu = length(nu);
lny = length(ny);
Ry = mloc.Ry;
Ru = mloc.Ru;




clear N A;

z = tf('z');
for k = 1:Q
    if ~rem(k,5)
        disp(num2str(k));
    end
    T = mloc.Mcell{k};
    
    
    % 2008-08-28 REDONDEO DE NUMEROS PEQUEOS A 0
    tol = 0.00001;
    T = T.*(~(abs(T)<tol));
    
    
    for i = 1:Ry
        for j = 1:Ry
            A(i,j) = tf(0,1,1);
            for n = 1:lny
                A(i,j) = A(i,j) + T(i,j + Ry*(n-1))*z^-ny(n);
            end
        end
    end
    for i = 1:Ry
        for j = 1:Ru
            N(i,j) = tf(0,1,1);
            for n = 1:lnu
                N(i,j) = N(i,j) + T(i,j + Ry*lny + Ru*(n-1))*z^-nu(n);
            end
        end
    end
    A = minreal(A);
    N = minreal(N);
    I = eye(length(A));
    mloc.G{k} = minreal(inv(I-A)*N);
    A_{k} = A;
    N_{k} = N;
    
    
% % %     % EXPERIMENTAL!! 2008-08-28 
% % %     % REDONDEO DE LOS ELEMENTOS DE G PARA PERMITIR CANCELACIONES
% % %     % Y POSTERIOR SIMPLIFICACION CON MINREAL
% % %     TOL = 10000;
% % %     for ii = 1:Ry, 
% % %         for jj = 1:Ru, 
% % %             mloc.G{k}.num{ii,jj} = round(mloc.G{k}.num{ii,jj}*TOL)/TOL; 
% % %             mloc.G{k}.den{ii,jj} = round(mloc.G{k}.den{ii,jj}*TOL)/TOL; 
% % %         end;
% % %     end;
% % %     mloc.G{k} = minreal(mloc.G{k});
% % %     % F_EXPERIMENTAL
    
    
    mloc.bias{k} = T(:,end);
end

