function [ptrans,A,b]=norpca(p,A,b,inversa);
% NORPCA Normalizacin PCA
%
%        [ptrans,A,b]=norpca(p,A,b,inversa);
%
% [ptrans,A,b]=norpca(p)                normalizacion pca ("prepca")
% [ptrans,A,b]=norpca(p,A,b)            normalizacion pca dados A y b ("trapca")
% [ptrans,A,b]=norpca(p,A,b,inversa)    desnormalizacion pca ("postpca");
%
%

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


[aux1,aux2]=size(p);

N = size(p,2);
if nargin==1
    b = mean(p,2);
    pm = p-b*ones(1,N);
    [u,s,v] = svd(pm*pm'/N);
    A = (u*sqrt(inv(s)))';
    ptrans = A*pm;
elseif nargin==3
    ptrans = A*(p-b*ones(1,N));
elseif nargin==4
    ptrans = inv(A)*p + b*ones(1,N);
end



