function pdfprint(archivo,tipo,imprimir_png);
% PDFPRINT genera un archivo PDF a partir de la figura actual
%          pdfprint(archivo,tipo);
%
%
% EJEMPLOS:
% pdfprint('pepe')      % Imprime en 'pepe.pdf' un archivo con el tamao de la
%                         figura (util para insertar en figura de LaTeX)
% pdfprint('pepe',1);   % Imprime en tamao A3 vertical
% pdfprint('pepe',2);   % Imprime en tamao A3 apaisado
%
%
% tipo==1  % A3: VERTICAL
% tipo==2  % A3: APAISADO
% tipo==3  % A5: APAISADO
% tipo==4  % A5: VERTICAL
% tipo==5  % CUADRADO (PEQUEO)
% tipo==6  % CUADRADO (MEDIANO)
% tipo==7  % CUADRADO (GRANDE)
% tipo==8  % A4: VERTICAL
% tipo==9  % A4: APAISADO
% tipo==10 % A MEDIDA

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


% set(gcf,'paperunits','inches');
% set(gcf,'paperposition',8*1.414*[0 0 1.414 1]);
% set(gcf,'papertype','a3');

if nargin >= 2
    if     tipo==1  % A3: VERTICAL
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',8*1.414*[0 0 1 1.414]);
        set(gcf,'papertype','a3');
    elseif tipo==2  % A3: APAISADO
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',8*1.414*[0 0 1.414 1]);
        set(gcf,'papertype','a3');
    elseif tipo==3  % A5: APAISADO
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',2*1.414*[0 0 1.414 1]);
        set(gcf,'papertype','a3');
    elseif tipo==4  % A5: VERTICAL
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',2*1.414*[0 0 1 1.414]);
        set(gcf,'papertype','a3');
    elseif tipo==5  % CUADRADO (PEQUEO)
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',2*[0 0 1 1]);
        set(gcf,'papertype','a3');
    elseif tipo==6  % CUADRADO (MEDIANO)
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',4*[0 0 1 1]);
        set(gcf,'papertype','a3');
    elseif tipo==7  % CUADRADO (GRANDE)
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',8*[0 0 1 1]);
        set(gcf,'papertype','a3');
    elseif tipo==8  % A4: VERTICAL
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',4*1.414*[0 0 1 1.414]);
        set(gcf,'papertype','a3');
    elseif tipo==9  % A4: APAISADO
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',4*1.414*[0 0 1.414 1]);
        set(gcf,'papertype','a3');
    elseif tipo==10  % A MEDIDA
        disp('pdfprint: tamao a medida...');
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',4*1.414*[0 0 3 .7]);
        set(gcf,'papertype','a3');
    else
        set(gcf,'paperunits','inches');
        set(gcf,'paperposition',4*1.414*tipo);
    end
end

% print -loose -depsc2 caca.eps;    % da problemas con los colormaps
% print -loose -depsc2 caca.eps;    % mete margenes algo amplios y se desaprovecha parte del espacio de la figura

% print -depsc2 -zbuffer caca.eps;
output_file=strcat(tempname,'.eps');
print(output_file,'-depsc2');
% setenv('PATH','/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/texbin:/usr/X11/bin');
% 2015-10-26: actualizacion para funcionar en Capitan
setenv('PATH','/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/Library/TeX/texbin:/usr/X11/bin');

cad = horzcat('epstopdf --outfile=',archivo,'.pdf ',output_file);
% cad = strcat('/usr/texbin/epstopdf --outfile=',archivo,'.pdf caca.eps');
system(cad);
%system('rm caca.eps');
delete(output_file);
if nargin==3
    disp('Imprimiendo version PNG...');
    print('-dpng','-r80',strcat(archivo,'.png'));
end
