function plotgrid(coords,dis,nodesize)
% PLOTGRID Plots SOM grid 
%    plotgrid(coords,dis,nodesize)
%

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

if nargin == 2
    nodesize = 10;
end


R     = size(coords,1);
[i,j] = find(triu(dis)==1);

if R == 1
    plotp([coords;zeros(1,smap.S)],'b'); hold on;
    plotp([coords;zeros(1,smap.S)],'r.',nodesize); hold off;
else
    plotp(coords,'r.',nodesize);
    if R == 2
        for k = 1:length(i)
            line(coords(1,[i(k) j(k)]),coords(2,[i(k) j(k)]));
        end
    elseif R >= 3
        for k = 1:length(i)
            line(coords(1,[i(k) j(k)]),coords(2,[i(k) j(k)]),coords(3,[i(k) j(k)]));
        end
    end    
end
    

