function plotp_scatter(p,tam,color,alpha);



N = size(p,2);              % Nmero de puntos
nv = 15;                    % Nmero de vrtices
th = linspace(0,2*pi,nv+1); 
th = th(1:nv);
u  = [cos(th);sin(th)];

if nargin==3
    alpha = repmat(0.25,[1,N]);
end


if length(alpha)==1                 % Si alpha tiene un solo valor, vectorizarlo
    alpha = repmat(alpha,[1,N]);
else
    alpha = mapminmax(alpha,0,1);   % Si alpha es vector, normalizarlo a (0,1)
end

if length(tam)==1                   % Si tam tiene un solo valor, vectorizarlo
    tam   = repmat(tam,  [1,N]);
end


cn    = mapminmax(color,-1,1);                  % Normalizar el color
rgb = interp1(linspace(-1,1,64),colormap,cn);   % Convertir a rgb mediante interpolacin


for k = 1:N
    patch(p(1,k)+u(1,:)*tam(k),p(2,k)+u(2,:)*tam(k),rgb(k,:),'facealpha',alpha(k),'edgealpha',0,'CData',color(k));
end



