function [A,index,resto,restoidx] = reforma(y,M,N)

% REFORMA Splits a 1D vector into overlapping windows
%
%         [A,index,resto,restoidx] = reforma(y,M,N)
%
% INPUTS
%    y: 1D vector of values (1xN)
%    M: # of samples that overlap between windows (integer)
%    N: Size in samples of each window (integer)

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


% ly = length(y);
% kl = floor((-N-1+ly)/(N-M));
% index = reshape(1:(kl+1)*N,N,kl+1) - M*ones(N,1)*(0:kl);
% A = y(index);

ly = length(y);
kl = floor((-N+ly)/(N-M));
index = reshape(1:(kl+1)*N,N,kl+1) - M*ones(N,1)*(0:kl);
A = y(index);

if index(end,end)<ly
    restoidx = (index(end)+1:ly)';
    resto    = y(restoidx);
    resto    = resto(:);
else
    resto = [];
    restoidx = [];
end