function region(hfig,Color)
% REGION Interactively highlight regions in the visualization space
%
% CALLS
%        region(hfig,Color)
%
%  hfig: Vector of handles to the SOM planes
% Color: String with a color code
%
% Description
%   REGION allows the user to highlight regions by clicking points with the mouse 
%   on any of the SOM maps. The polygon line enclosing a region will be
%   drawn for all the SOM maps regardless where the points have been
%   clicked. Points can even be clicked on planes from other different
%   figure since the 2D coordinates in V are the only information needed.

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


[x,y]=ginput;
for k = 1:length(hfig)
    axes(hfig(k));
    hold on;
    if nargin==1
        plot(x,y,'k','LineWidth',2);
    elseif nargin==2
        plot(x,y,Color,'LineWidth',2);
    end      
    hold off;
end
