function smap=setlimits(smap)

% SETLIMITS Allows to change prespecified color ranges for variables
%
% CALLS
% smap = setlimits(smap)
%
% smap: SOM structure
%
% Description
%   SETLIMITS allows to change the scale in which SOM planes are displayed
%   in an interactive way, by clicking twice in the colorbars of the planes
%   whose variable range is to be changed.

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


original_limits = smap.limits;

while 1
    [hfig,hbar]=planes(smap);
    [x,y,b] = ginput(2);
    if isempty(b)
        break;
    elseif b(2)==1        
        idx = find(hbar==gca);
        smap.limits(idx,:) = sort(y);   
    elseif b(2)==3
        idx = find(hbar==gca);        
        smap.limits(idx,:) = original_limits(idx,:);
    end
    axis(axes);
    grid on;
end