function [yest,qerr,resn,bmu] = somtst(x,som,vars)
%        [yest,qerr,resn,bmu] = somtst(x,som,vars)
%

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


varin  = som.varin;
varout = som.varout;

if nargin == 2
    vars = 1:length(varin);
end




mu = som.norm{1};
sig= som.norm{2};
npar.meanx=mu(varin(vars));
npar.stdx=sig(varin(vars));
npar.type='std';

xn = normalize_data('apply',x,npar);


[qerr,bmu] = min(matdist(som.w(:,varin(vars))',xn));

xnest = som.w(bmu,varin(vars))';
ynest = som.w(bmu,varout)';
resn  = xn-xnest;
res   = normalize_data('reverse',xn,npar)-normalize_data('reverse',xnest,npar);
npar.meanx=mu(varout);
npar.stdx=sig(varout);
yest  = normalize_data('reverse',ynest,npar);





