function idx = strnmatch(labelset1,labelset2)
% STRNMATCH Gets the index in labelset2 corresponding to features
%           specified in labelset1
% CALLS
%       idx = strnmatch(labelset1,labelset2)
%


%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


N = length(labelset1);

idx = [];
for k = 1:N
    idx_k = strmatch(labelset1{k},labelset2);
    idx = [idx idx_k(:)' ];
end

[aux,i]= unique(idx);

idx = idx(sort(i)); 
