function [psort] = tablelens(p,labels)
% TABLELENS Visualizacion tipo Table Lens en imagen con mapa de colores
%
%       [psort] = tablelens(p,labels)
%
%       p: Matriz de datos (RxQ) por columnas
%  labels: {1xR} cell array con etiquetas para las R caracteristicas
%
% DESCRIPTION
%   Dibuja en R graficos la evolucion de caracteristicas frente al tiempo
%
% VER TAMBIEN
%   tablelens, 

%   Copyright (c) 2007, by 
%   Grupo de Supervisin y Diagnstico de Procesos Industriales
%   Area de Ingeniera de Sistemas y Automtica
%   Universidad de Oviedo
%   Contributed files may contain copyrights of their own.
%   
%   UniOviSOM toolbox is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



fontsize = 8;


[R,N]=size(p);

p = normalize_data('mnmx',p);

if nargin==1
    for k = 1:R
        labels{k} = ['Var: ', num2str(k)];
    end
end


% GENERAMOS LOS GRAFICOS
clf;
varplot(p,labels,'alt');


while 1
    [x,y,b]=ginput(1);
    if length(x)==0
        break
    end
    [dummy,idx]=sort(p(R-round(y)+1,:));
    varplot(p(:,idx),labels,'alt');
end


psort = p(:,idx);

